## restfuldb 0.15.0+dfsg

=== Makefile ===
#---*- Makefile -*-------------------------------------------------------
#$Author: andrius $
#$Date: 2020-02-10 05:26:39 -0500 (Mon, 10 Feb 2020) $
#$Revision: 5927 $
#$URL: svn://saulius-grazulis.lt/restful/tags/v0.15.0/Makefile $
#------------------------------------------------------------------------

# Run tests in a test directory (tests/ by default) and report if
# all tests pass.

# USAGE:
#     make clean
#     make distclean
#     make tests
#     make

#------------------------------------------------------------------------------

# Include local configuration files from this directory:

MAKECONF_FILES = ${filter-out %~, ${wildcard Makeconf*}}

ifneq ("${MAKECONF_FILES}","")
include ${MAKECONF_FILES}
endif

#------------------------------------------------------------------------------

# Use local scripts as a fall-back when hey are not installed on the system:
PATH := ${PATH}:tools/scripts

BIN_DIR  = website/cgi-bin

TEST_DIR = tests/cases
OUTP_DIR = tests/outputs

INP_FILES  = ${wildcard ${TEST_DIR}/*.inp}
OPT_FILES  = ${wildcard ${TEST_DIR}/*.opt}
SH_FILES   = ${wildcard ${TEST_DIR}/*.sh}

INP_DIFFS = ${INP_FILES:${TEST_DIR}/%.inp=${OUTP_DIR}/%.diff}
INP_OUTS  = ${INP_FILES:${TEST_DIR}/%.inp=${OUTP_DIR}/%.out}

OPT_DIFFS = ${OPT_FILES:${TEST_DIR}/%.opt=${OUTP_DIR}/%.diff}
OPT_OUTS  = ${OPT_FILES:${TEST_DIR}/%.opt=${OUTP_DIR}/%.out}

SH_DIFFS = ${SH_FILES:${TEST_DIR}/%.sh=${OUTP_DIR}/%.diff}
SH_OUTS  = ${SH_FILES:${TEST_DIR}/%.sh=${OUTP_DIR}/%.out}

DIFF_FILES = $(sort ${INP_DIFFS} ${OPT_DIFFS} ${SH_DIFFS})
OUTP_FILES = $(sort ${INP_OUTS} ${OPT_OUTS} ${SH_OUTS})

.PHONY: all clean cleanAll distclean test tests out outputs display

all: ${COMPILED_MODULES} tests

display:
	@echo ${DIFF_FILES}

#------------------------------------------------------------------------------

# Include Makefiles with additional rules for this directory:

MAKELOCAL_FILES = ${filter-out %~, ${wildcard Makelocal*}}

ifneq ("${MAKELOCAL_FILES}","")
include ${MAKELOCAL_FILES}
endif

#------------------------------------------------------------------------------

test tests: ${DIFF_FILES}

${DIFF_FILES}: 

out outputs: ${OUTP_FILES}

#------------------------------------------------------------------------------

# Dependencies for the test files:

include .depend .shdepend

.depend: ${INP_OUTS} ${OPT_OUTS} ${SH_OUTS}
	for i in $^; do \
		echo "$$i: $$(echo $$i | sed -e 's/_[0-9]*\..*$$//' \
			| sed 's,${OUTP_DIR},${BIN_DIR},')"; \
	done | grep -v '\.pm' | grep -v '\.js' | grep -v 'out$$' > $@

.shdepend: ${SH_FILES}
	BIN_DIR=${BIN_DIR} mkcomdepend $^ > $@

#------------------------------------------------------------------------------

# Define common test frame components:

define source_environment
test -f $(dir $<)/$*.env && . $(dir $<)/$*.env
endef

define can_run_test
[ ! -e ${TEST_DIR}/$*.chk ] || ${TEST_DIR}/$*.chk
endef

define diff_outputs
diff -I 'Expires:\|Date:' ${OUTP_DIR}/$*.out -
endef

define report_differences
if [ $$? = 0 ]; then echo "OK"; else echo "FAILED:"; cat $@; fi
endef

# Filters for the test outputs:

define filter_perl_messages
tools/scripts/validate-inner-html | \
perl -pe '\
     s/Id: [-\w]+ \d+ [-\d]+ [:\dZ]+ \w+/Id: <script_name> <revision_nr> <date> <time> <author>/; \
     s,at ([-\.\/\w\d]+|\([^\)]+\)) line \d+\.?,at <script_name> line <line_no>.,; \
     s/, (<|&lt;)DATA(>|&gt;) line 1\.//g; \
     s/(unknown MySQL server host .*?)(\(\d*\))\.?$$/$$1(<error code>)./; \
     s/tmp\w+\d+sh\d+(\.db)?/<database>/g; \
     s/(DBI connect)\(.*\)( failed:)/$$1(<database args>)$$2/; \
     s/^(Date|Expires): \w{3}, \d{2} \w{3} \d{4} .*/$$1: <date>/; \
     s,tests/no-taint-checks/,website/cgi-bin/,; \
     s,tests/bin/,website/cgi-bin/,; \
     s/[a-f0-9]{8}(-[a-f0-9]{4}){3}-[a-f0-9]{12}/<uuid>/g; \
     s/\d{4}(-\d{2}){2}T\d{2}(:\d{2}){2}Z/<timestamp>/g; \
     s/RestfulDB version: v\d+\.\d+\.\d+/<version>/g; \
    '
endef

# Rules to run script-specific tests:

${OUTP_DIR}/%.diff: ${TEST_DIR}/%.inp ${TEST_DIR}/%.opt ${OUTP_DIR}/%.out ${COMPILED_MODULES} ${PERL_MODULES} ${PERL_TOOLS}
	-@printf "%-50s " "$<:" ; \
	if ${can_run_test}; then \
		${source_environment} ; \
		${BIN_DIR}/$(shell echo $* | sed -e 's/_[0-9]*$$//') \
		    $(shell grep -v '^#' ${word 2, $^}) \
	    	< $< 2>&1 \
		| ${filter_perl_messages} \
		| ${diff_outputs} > $@ ; \
		${report_differences} ; \
	else \
		touch $@; \
	fi

${OUTP_DIR}/%.diff: ${TEST_DIR}/%.inp ${OUTP_DIR}/%.out ${COMPILED_MODULES} ${PERL_MODULES} ${PERL_TOOLS}
	-@printf "%-50s " "$<:" ; \
	if ${can_run_test}; then \
		${source_environment} ; \
		${BIN_DIR}/$(shell echo $* | sed -e 's/_[0-9]*$$//') \
		    < $< 2>&1 \
		| ${filter_perl_messages} \
		| ${diff_outputs} > $@ ; \
		${report_differences} ; \
	else \
		touch $@; \
	fi

${OUTP_DIR}/%.diff: ${TEST_DIR}/%.opt ${OUTP_DIR}/%.out ${COMPILED_MODULES} ${PERL_MODULES} ${PERL_TOOLS}
	-@printf "%-50s " "$<:" ; \
	if ${can_run_test}; then \
		${source_environment} ; \
		${BIN_DIR}/$(shell echo $* | sed -e 's/_[0-9]*$$//') \
		    $(shell grep -v '^#' $<) \
		< /dev/null 2>&1 \
		| ${filter_perl_messages} \
		| ${diff_outputs} > $@ ; \
		${report_differences} ; \
	else \
		touch $@; \
	fi

${OUTP_DIR}/%.diff: ${TEST_DIR}/%.sh ${OUTP_DIR}/%.out ${COMPILED_MODULES} ${PERL_MODULES} ${PERL_TOOLS}
	-@printf "%-50s " "$<:" ; \
	if ${can_run_test}; then \
		${source_environment} ; \
		$< 2>&1 \
		| ${filter_perl_messages} \
		| ${diff_outputs} > $@ ; \
		${report_differences} ; \
	else \
		touch $@; \
	fi

# Rules to generate sample test outputs:

${OUTP_DIR}/%.out: ${TEST_DIR}/%.inp ${TEST_DIR}/%.opt ${COMPILED_MODULES} ${PERL_MODULES} ${PERL_TOOLS}
	-@test -f $@ || echo "$@:"
	-@${source_environment}; \
	test -f $@ || \
	${BIN_DIR}/$(shell echo $* | sed -e 's/_[0-9]*$$//') \
	    $(shell grep -v '^#' ${word 2, $^}) \
	    < $< \
	2>&1 \
	| ${filter_perl_messages} \
	| tee $@
	-@touch $@

${OUTP_DIR}/%.out: ${TEST_DIR}/%.inp ${COMPILED_MODULES} ${PERL_MODULES} ${PERL_TOOLS}
	-@test -f $@ || echo "$@:"
	-@${source_environment}; \
	test -f $@ || \
	${BIN_DIR}/$(shell echo $* | sed -e 's/_[0-9]*$$//') \
	    < $< \
	2>&1 \
	| ${filter_perl_messages} \
	| tee $@
	-@touch $@

${OUTP_DIR}/%.out: ${TEST_DIR}/%.opt ${COMPILED_MODULES} ${PERL_MODULES} ${PERL_TOOLS}
	-@test -f $@ || echo "$@:"
	-@${source_environment}; \
	test -f $@ || \
	${BIN_DIR}/$(shell echo $* | sed -e 's/_[0-9]*$$//') \
	    $(shell grep -v '^#' $<) \
	2>&1 \
	< /dev/null \
	| ${filter_perl_messages} \
	| tee $@
	-@touch $@

${OUTP_DIR}/%.out: ${TEST_DIR}/%.sh ${COMPILED_MODULES} ${PERL_MODULES} ${PERL_TOOLS}
	-@test -f $@ || echo "$@:"
	-@${source_environment}; \
	test -f $@ || \
	$< 2>&1 \
	| ${filter_perl_messages} \
	| tee $@
	-@touch $@

#------------------------------------------------------------------------------

.PHONY: failed listdiff

failed listdiff: ## test
	@-find ${OUTP_DIR} -type f -name '*.diff' -size +0 | sort -u

#------------------------------------------------------------------------------

clean:
	rm -f ${DIFF_FILES}

distclean cleanAll: clean
	rm -f .depend .shdepend
	rm -f ${PERL_MODULES}
	rm -f ${PERL_TOOLS}

=== debian/changelog ===
restfuldb (0.15.0+dfsg-1) unstable; urgency=medium

  * New upstream version 0.15.0+dfsg.
  * Feather icons are gone from upstream tarball.
  * Removing upstream-integrated patches.
  * Refreshing no-build-dependencies.patch.
  * Adding a dependency on libfile-libmagic-perl.
  * Reordering dependencies.
  * Running tests for Database::Filter.

 -- Andrius Merkys <merkys@debian.org>  Mon, 10 Aug 2020 11:40:15 -0400

restfuldb (0.14.2+dfsg-5) unstable; urgency=medium

  * Skipping Database::Filter tests, as they depend on the used version of
    OPTIMADE::Filter.

 -- Andrius Merkys <merkys@debian.org>  Thu, 11 Jun 2020 00:42:02 -0400

restfuldb (0.14.2+dfsg-4) unstable; urgency=medium

  * Adding autopkgtest dependency on libxml2-utils.

 -- Andrius Merkys <merkys@debian.org>  Fri, 22 May 2020 14:43:34 -0400

restfuldb (0.14.2+dfsg-3) unstable; urgency=medium

  * Adding missing autopkgtest dependency on sqlite3.

 -- Andrius Merkys <merkys@debian.org>  Thu, 21 May 2020 16:16:19 -0400

restfuldb (0.14.2+dfsg-2) unstable; urgency=medium

  * Adding a patch to adjust to the changed interface of OPTIMADE::Filter.
  * Updating versioned dependency on liboptimade-filter-perl.

 -- Andrius Merkys <merkys@debian.org>  Wed, 20 May 2020 09:18:36 -0400

restfuldb (0.14.2+dfsg-1) unstable; urgency=medium

  * New upstream version 0.14.2+dfsg.
  * Updating Files-Excluded.
  * Refreshing patches.
  * Adding versioned depends on liboptimade-filter-perl.
  * Backporting an upstream fix as Database-r6707-6714.patch.
  * Skipping RestfulDB-JSON.pm_004 test which depends on the version of
    JSON::PP.
  * Updating dependencies.

 -- Andrius Merkys <merkys@debian.org>  Wed, 22 Apr 2020 06:18:47 -0400

restfuldb (0.14.0+dfsg-2) unstable; urgency=medium

  * Adding license for externals/CGIParameters/*.

 -- Andrius Merkys <merkys@debian.org>  Mon, 20 Apr 2020 07:23:33 -0400

restfuldb (0.14.0+dfsg-1) unstable; urgency=low

  * Initial release (Closes: #951332)

 -- Andrius Merkys <merkys@debian.org>  Mon, 17 Feb 2020 12:17:20 -0500

## restfuldb 0.15.2%2Bdfsg

=== debian/control ===
Source: restfuldb
Priority: optional
Section: web
Maintainer: Andrius Merkys <merkys@debian.org>
Build-Depends:
 debhelper-compat (= 12),
 dh-apache2,
 libarchive-zip-perl <!nocheck>,
 libcgi-pm-perl <!nocheck>,
 libclone-perl <!nocheck>,
 libdata-uuid-perl <!nocheck>,
 libdata-validate-uri-perl <!nocheck>,
 libdatetime-perl <!nocheck>,
 libdbd-sqlite3-perl <!nocheck>,
 libdbi-perl <!nocheck>,
 libexcel-writer-xlsx-perl <!nocheck>,
 libexception-class-perl <!nocheck>,
 libfile-libmagic-perl <!nocheck>,
 libfile-mimeinfo-perl <!nocheck>,
 libhash-merge-perl <!nocheck>,
 libio-string-perl <!nocheck>,
 libjson-perl <!nocheck>,
 liblist-moreutils-perl <!nocheck>,
 libobject-lazy-perl <!nocheck>,
 liboptimade-filter-perl (>= 0.9.0) <!nocheck>,
 libspreadsheet-read-perl <!nocheck>,
 libspreadsheet-wright-perl <!nocheck>,
 libspreadsheet-xlsx-perl <!nocheck>,
 libtext-csv-encoded-perl <!nocheck>,
 libtext-csv-perl <!nocheck>,
 libtext-csv-xs-perl <!nocheck>,
 libtext-markdown-perl <!nocheck>,
 libtext-sprintfn-perl <!nocheck>,
 liburi-encode-perl <!nocheck>,
 libwww-perl <!nocheck>,
 libxml-libxml-perl <!nocheck>,
 libxml2-utils <!nocheck>,
 rename,
 sqlite3 <!nocheck>,
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: https://projects.ibt.lt/repositories/projects/restfuldb
Vcs-Browser: https://salsa.debian.org/merkys/restfuldb
Vcs-Git: https://salsa.debian.org/merkys/restfuldb.git

Package: librestfuldb-perl
Architecture: all
Section: perl
Depends:
 libarchive-zip-perl,
 libcgi-pm-perl,
 libclone-perl,
 libdata-uuid-perl,
 libdatetime-perl,
 libdbd-mysql-perl,
 libdbd-sqlite3-perl,
 libdbi-perl,
 libexcel-writer-xlsx-perl,
 libexception-class-perl,
 libfile-libmagic-perl,
 libhash-merge-perl,
 libio-string-perl,
 libjson-perl,
 libobject-lazy-perl,
 liboptimade-filter-perl (>= 0.9.0),
 libspreadsheet-read-perl,
 libspreadsheet-wright-perl,
 libspreadsheet-xlsx-perl,
 libtext-csv-encoded-perl,
 libwww-perl,
 ${misc:Depends},
 ${perl:Depends},
Description: Web frontend for relational databases - Perl modules
 RestfulDB is a Web frontend for SQL databases. It provides both a Web GUI
 and a RESTful API for interaction with any MySQL/MariaDB or SQLite database.
 RestfulDB is developed with off-the-shelf usage in mind, but nevertheless
 it provides the means to override the default interpretations of underlying
 database's schema and data.
 .
 This package contains Perl modules required by RestfulDB.

Package: restfuldb
Architecture: all
Depends:
 apache2,
 javascript-common,
 libauthen-oath-perl,
 libcgi-pm-perl,
 libdata-validate-uri-perl,
 libdatetime-perl,
 libexcel-writer-xlsx-perl,
 libfile-mimeinfo-perl,
 libhash-merge-perl,
 libhtml-fromtext-perl,
 libjs-jquery,
 libjs-select2.js,
 liblist-moreutils-perl,
 librestfuldb-perl,
 libspreadsheet-wright-perl,
 libtext-csv-perl,
 libtext-csv-xs-perl,
 libtext-markdown-perl,
 libtext-sprintfn-perl,
 liburi-encode-perl,
 liburl-encode-perl,
 libxml-libxml-perl,
 ${misc:Depends},
 ${perl:Depends},
Recommends:
 ${misc:Recommends},
Description: Web frontend for relational databases
 RestfulDB is a Web frontend for SQL databases. It provides both a Web GUI
 and a RESTful API for interaction with any MySQL/MariaDB or SQLite database.
 RestfulDB is developed with off-the-shelf usage in mind, but nevertheless
 it provides the means to override the default interpretations of underlying
 database's schema and data.

## restfuldb 0.15.2+dfsg

=== Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 #$Author: andrius $
 #$Date: 2020-02-10 05:26:39 -0500 (Mon, 10 Feb 2020) $
 #$Revision: 5927 $
-#$URL: svn://saulius-grazulis.lt/restful/tags/v0.15.0/Makefile $
+#$URL: svn://saulius-grazulis.lt/restful/tags/v0.15.2/Makefile $
 #------------------------------------------------------------------------
 
 # Run tests in a test directory (tests/ by default) and report if

=== debian/changelog ===
restfuldb (0.15.2+dfsg-1) unstable; urgency=medium

  * New upstream version 0.15.2+dfsg.
  * Bumping copyright years.

 -- Andrius Merkys <merkys@debian.org>  Mon, 11 Jan 2021 09:47:19 -0500

restfuldb (0.15.1+dfsg-1) unstable; urgency=medium

  * New upstream version 0.15.1+dfsg.

 -- Andrius Merkys <merkys@debian.org>  Mon, 28 Dec 2020 06:09:54 -0500

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

CONF = debian/restfuldb/etc/apache2/conf-available/restfuldb.conf

%:
	dh $@ --with apache2

override_dh_auto_build:
	make lib/RestfulDB/Version.pm

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	find tests/outputs -name '*.out' | sort \
		| grep '^tests/outputs/[A-Z]' \
		| grep -v Database-View \
		| grep -v RestfulDB-JSON.pm_004 \
		| sed 's/\.out$$/.diff/' | xargs $(MAKE)
	find tests/outputs -name '*.diff' -a -size +0c \
		| xargs --no-run-if-empty false
endif

override_dh_auto_install:
	rename 's/([^\/]+)$$/restfuldb-$$1/' \
		website/cgi-bin/db.pl \
		website/cgi-bin/image.pl \
		website/cgi-bin/modify.pl \
		website/cgi-bin/notfound.pl \
		website/cgi-bin/tables.pl
	sed -i 's/\.\.\/\.\.\/js/\/javascript\/restfuldb\//g' website/cgi-bin/restfuldb-*
	sed -i 's/\.\.\/js/\/javascript\/restfuldb\//g'       website/cgi-bin/restfuldb-*
	mv externals/CGIParameters/lib/CGIParameters.pm lib
	rm -rf lib/RestfulDB/Version.pmin
	mv lib perl5
	ln -fs /usr/share/javascript/jquery/jquery.js website/js/jquery.js
	ln -fs /usr/share/javascript/jquery/jquery.js website/js/jquery-*.js
	ln -fs /usr/share/javascript/select2.js/select2.js website/js/select2.js
	ln -fs /usr/share/javascript/select2.js/select2.css website/styles/default/select2.css

override_dh_install:
	dh_install
	rm -rf debian/restfuldb/usr/share/restfuldb/perl5/RestfulDB
	echo 'Alias /restfuldb /usr/share/restfuldb' >> ${CONF}
	echo '<Directory /usr/share/restfuldb>'      >> ${CONF}
	cat website/.htaccess			     >> ${CONF}
	echo '</Directory>'			     >> ${CONF}

=== debian/tests/control ===
Tests: upstream
Depends:
 libxml2-utils,
 rsync,
 sqlite3,
 @,
Restrictions: allow-stderr

=== debian/watch ===
version=4
opts="mode=svn, pgpmode=none, repack, repacksuffix=+dfsg, dversionmangle=s/\+dfsg$//" \
 svn://saulius-grazulis.lt/restful/tags/ \
 v([\d.]+)\/ debian uupdate

## restfuldb 0.16.0%2Bdfsg

=== debian/changelog ===
restfuldb (0.16.0+dfsg-1) unstable; urgency=medium

  * New upstream version 0.16.0+dfsg.
  * Bump copyright year.
  * Drop upstream-integrated patch.
  * List new dependency.

 -- Andrius Merkys <merkys@debian.org>  Thu, 05 May 2022 12:12:51 -0400

restfuldb (0.15.2+dfsg-3) unstable; urgency=medium

  * Simplifying debian/watch.
  * Restoring compatibility with SQLite3 3.37.0 (Closes: #1003307).
  * Removing unused lintian override, false-positive in lintian << 2.105.0.
  * Marking all patches 'Forwarded: not-needed'.
  * Adjusting lintian override for web-application-works-only-with-apache.
  * Bumping copyright years.

 -- Andrius Merkys <merkys@debian.org>  Tue, 18 Jan 2022 03:40:53 -0500

restfuldb (0.15.2+dfsg-2) unstable; urgency=medium

  * Removing explicit dependency on libdbd-sqlite2-perl.
  * Skipping tests requiring libdbd-sqlite2-perl.

 -- Andrius Merkys <merkys@debian.org>  Thu, 11 Nov 2021 01:52:08 -0500

## restfuldb 0.16.0+dfsg

=== Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 #$Author: andrius $
 #$Date: 2020-02-10 05:26:39 -0500 (Mon, 10 Feb 2020) $
 #$Revision: 5927 $
-#$URL: svn://saulius-grazulis.lt/restful/tags/v0.15.2/Makefile $
+#$URL: svn://saulius-grazulis.lt/restful/tags/v0.16.0/Makefile $
 #------------------------------------------------------------------------
 
 # Run tests in a test directory (tests/ by default) and report if

=== doc/Makefile ===
# --*- Makefile -*-------------------------------------------------------------
#$Author: saulius $
#$Date: 2019-08-14 10:25:26 +0300 (Wed, 14 Aug 2019) $
#$Revision: 213 $
#$URL: svn+ssh://saulius-grazulis.lt/home/saulius/svn-repositories/makefiles/Makefile-backbone $
#------------------------------------------------------------------------------

MAKEFILE_DIRS = . makefiles/enabled
MAKEFILE_WCARDS = $(addsuffix /Makelocal*, ${MAKEFILE_DIRS})
MAKECONF_WCARDS = $(addsuffix /Makeconf*, ${MAKEFILE_DIRS})

MAKECONF_FILES = $(filter-out %.example, \
	$(filter-out %~, $(wildcard ${MAKECONF_WCARDS}) \
))

ifneq ("${MAKECONF_FILES}","")
include ${MAKECONF_FILES}
endif

.PHONY: all clean distclean cleanAll

all:

clean:

cleanAll distclean: clean

MAKELOCAL_FILES = ${filter-out %~, ${wildcard ${MAKEFILE_WCARDS}}}

ifneq ("${MAKELOCAL_FILES}","")
include ${MAKELOCAL_FILES}
endif

=== debian/changelog ===
restfuldb (0.16.0+dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix "FTBFS with Perl 5.40: test failures": add patch from Niko Tyni to fix
    import with Perl 5.40.
    (Closes: #1078202)

 -- gregor herrmann <gregoa@debian.org>  Mon, 16 Sep 2024 23:47:32 +0200

=== debian/control ===
--- 
+++ 
@@ -18,6 +18,7 @@
  libfile-libmagic-perl <!nocheck>,
  libfile-mimeinfo-perl <!nocheck>,
  libhash-merge-perl <!nocheck>,
+ libhtml-restrict-perl <!nocheck>,
  libio-string-perl <!nocheck>,
  libjson-perl <!nocheck>,
  liblist-moreutils-perl <!nocheck>,
@@ -92,6 +93,7 @@
  libfile-mimeinfo-perl,
  libhash-merge-perl,
  libhtml-fromtext-perl,
+ libhtml-restrict-perl,
  libjs-jquery,
  libjs-select2.js,
  liblist-moreutils-perl,
